#include <iostream>

using namespace std;

struct Cvor {
    Cvor(int n):vrednost(n){};
    int vrednost;
    Cvor *levo = nullptr;
    Cvor *desno = nullptr;
};

Cvor* dodaj_u_stablo(Cvor *koren, int n)
{
    if(koren == nullptr)
        return new Cvor(n);
    
    if(n <= koren->vrednost)
        koren->levo = dodaj_u_stablo(koren->levo, n);
    else
        koren->desno = dodaj_u_stablo(koren->desno, n);
    
    return koren;
}

void LKD(Cvor *koren)
{
    if(koren != nullptr)
    {
        LKD(koren->levo);
        cout << koren->vrednost << " ";
        LKD(koren->desno);
    }
}

void oslobodi(Cvor *koren)
{
    if(koren != nullptr)
    {
        oslobodi(koren->levo);
        oslobodi(koren->desno);
        delete koren;
    }
}

int min_u(Cvor *koren)
{
    if(koren->levo == nullptr)
        return koren->vrednost;
    else
        return min_u(koren->levo);
}

int max_u(Cvor *koren)
{
    if(koren->desno == nullptr)
        return koren->vrednost;
    else
        return min_u(koren->desno);
}

bool BST_1(Cvor *koren)
{
    if(koren == nullptr)
        return true;
    
    if(koren->levo != nullptr)
        if(max_u(koren->levo) > koren->vrednost || !BST_1(koren->levo))
            return false;
    
    if(koren->desno != nullptr)
        if(min_u(koren->desno) < koren->vrednost || !BST_1(koren->desno))
            return false;
    
    return true;
}

struct Status
{
    bool bst_status;
    int min;
    int max;
};

Status BST_2(Cvor *koren)
{
    if(koren == nullptr)
    {
        Status odgovor;
        odgovor.min = 0;
        odgovor.max = 0;
        odgovor.bst_status = true;
        
        return odgovor;
    }
    
    if(koren->levo == nullptr && koren->desno == nullptr)
    {
        Status odgovor;
        odgovor.min = koren->vrednost;
        odgovor.max = koren->vrednost;
        odgovor.bst_status = true;
        
        return odgovor;
    }
    
    Status odgovor_l;
    Status odgovor_d;
    Status odgovor;
    
    if(koren->levo != nullptr)
    {
        odgovor_l = BST_2(koren->levo);
        if(odgovor_l.bst_status == false || odgovor_l.max > koren->vrednost)
        {
            odgovor.bst_status = false;
            return odgovor;
        }
        
        odgovor.min = odgovor_l.min;
    }
    
    if(koren->desno != nullptr)
    {
        odgovor_d = BST_2(koren->desno);
        if(odgovor_d.bst_status == false || odgovor_d.min < koren->vrednost)
        {
            odgovor.bst_status = false;
            return odgovor;
        }
        
        odgovor.max = odgovor_d.max;
    }
    
    odgovor.bst_status = true;
    return odgovor;  
}

bool BST_3(int &min, int &max, Cvor *koren)
{
    if(koren == nullptr)
        return true;
    
    int min_t;
    int max_t;
    
    min_t = koren->vrednost;
    max_t = koren->vrednost;
    
    if(koren->levo != nullptr)
    {
        bool l = BST_3(min, max, koren->levo);
        if (l == false || max > koren->vrednost)
            return false;
        
        min_t = min;
    }
    
    if(koren->desno != nullptr)
    {
        bool d = BST_3(min, max, koren->desno);
        if (d == false || min < koren->vrednost)
            return false;
        
        max_t = max;
    }
    
    min = min_t;
    max = max_t;

    //cout << min << ", " << max << endl;
    
    return true;
}

int main()
{
    Cvor *koren = nullptr;
 
    koren = dodaj_u_stablo(koren, 4);
    koren = dodaj_u_stablo(koren, 2);
    koren = dodaj_u_stablo(koren, 3);
    koren = dodaj_u_stablo(koren, 1);
    koren = dodaj_u_stablo(koren, 6);
    koren = dodaj_u_stablo(koren, 7);
    koren = dodaj_u_stablo(koren, 5);
    
   // LKD(koren);
    
    //koren->levo->desno->vrednost = 10;
    //koren->desno->levo->vrednost = -1;
    
    int min, max;
    
    if(BST_3(min, max, koren))
        cout << "Jeste BST";
    else
        cout << "Nije BST";
    
    oslobodi(koren);
    
    return 0;
}
