#include <iostream>
#include <cstdlib>
#include <vector>

using namespace std;

struct Cvor {
    Cvor(char c):vrednost(c){};
    char vrednost;
    Cvor *levo = nullptr;
    Cvor *desno = nullptr;
};

/* ---- Pomocne funkcije ------- */

void LKD(Cvor *koren)
{
    if(koren != nullptr)
    {
        LKD(koren->levo);
        cout << koren->vrednost << " ";
        LKD(koren->desno);
    }
}

void KLD(Cvor *koren)
{
    if(koren != nullptr)
    {
        cout << koren->vrednost << " ";
        KLD(koren->levo);
        KLD(koren->desno);
    }
}


void oslobodi(Cvor *koren)
{
    if(koren != nullptr)
    {
        oslobodi(koren->levo);
        oslobodi(koren->desno);
        delete koren;
    }
}

/*---------------------*/


Cvor *rekonstrukcija(int kld_l, int kld_d, int lkd_l, int lkd_d, vector<char> &kld, vector<char> &lkd)
{
    if(kld_l > kld_d || lkd_l > lkd_d)
        return nullptr;
    
    Cvor *koren = new Cvor(kld[kld_l]);
    
    int i;
    for(i = lkd_l; i < lkd.size(); i++)
        if(lkd[i] == koren->vrednost)
            break;
        
    if(i == lkd.size() || i > lkd_d)
    {
        cerr << "Neispravni obilasci!" << endl;
        exit(EXIT_FAILURE);
    }
    
    int broj_levo = i - lkd_l - 1;
    
    koren->levo = rekonstrukcija(kld_l + 1, kld_l + 1 + broj_levo, lkd_l, i-1, kld, lkd);
    koren->desno = rekonstrukcija(kld_l + 1 + broj_levo + 1, kld_d, i+1, lkd_d, kld, lkd);
    
    return koren;
}

int main()
{
    int n;
    
    vector<char> lkd;
    vector<char> kld;
    
    cout << "Broj cvorova: ";
    cin >> n;
 
    if(n <= 0)
    {
        cerr << "Neispravan broj cvorova!" << endl;
        return -1;
    }
    
    char c;
    
    cout << "LKD: ";
    for(int i = 0; i < n; i++)
    {
        cin >> c;
        lkd.push_back(c);
    }
    
    cin.get(c);
    
    cout << "KLD: ";
    for(int i = 0; i < n; i++)
    {
        cin >> c;
        kld.push_back(c);
    }
    
    Cvor *koren = rekonstrukcija(0, n-1, 0, n-1, kld, lkd);
    
    LKD(koren);
    cout << endl;
    KLD(koren);
    
    
    
    oslobodi(koren);
    
    return 0;
}