#include <iostream>

using namespace std;

struct Cvor {
    Cvor(int n):vrednost(n){};
    int vrednost;
    Cvor *levo = nullptr;
    Cvor *desno = nullptr;
};

/* ---- Pomocne funkcije ------- */

Cvor* dodaj_u_stablo(Cvor *koren, int n)
{
    if(koren == nullptr)
        return new Cvor(n);
    
    if(n <= koren->vrednost)
        koren->levo = dodaj_u_stablo(koren->levo, n);
    else
        koren->desno = dodaj_u_stablo(koren->desno, n);
    
    return koren;
}

void LKD(Cvor *koren)
{
    if(koren != nullptr)
    {
        LKD(koren->levo);
        cout << koren->vrednost << " ";
        LKD(koren->desno);
    }
}

void oslobodi(Cvor *koren)
{
    if(koren != nullptr)
    {
        oslobodi(koren->levo);
        oslobodi(koren->desno);
        delete koren;
    }
}

/*---------------------*/


int kriticni(Cvor *koren)
{
    if(koren == nullptr)
        return 0;
    
    int broj_cvorova_levo = kriticni(koren->levo);
    int broj_cvorova_desno = kriticni(koren->desno);
    
    if(broj_cvorova_desno == -1 || broj_cvorova_desno == -1)
        return -1;
    
    if(abs(broj_cvorova_levo - broj_cvorova_desno) <= 1)
        return broj_cvorova_levo + broj_cvorova_desno + 1;
    else
    {
        cout << koren->vrednost << " ";
        return -1;
    }
    
}

int main()
{
    Cvor *koren = nullptr;
    
    koren = dodaj_u_stablo(koren, 1);
    koren = dodaj_u_stablo(koren, 2);
    koren = dodaj_u_stablo(koren, 3);
    koren = dodaj_u_stablo(koren, 4);
    koren = dodaj_u_stablo(koren, 10);
    koren = dodaj_u_stablo(koren, 9);
    koren = dodaj_u_stablo(koren, 11);
    koren = dodaj_u_stablo(koren, -1);
    koren = dodaj_u_stablo(koren, -2);
    koren = dodaj_u_stablo(koren, -3);
    koren = dodaj_u_stablo(koren, -7);
    koren = dodaj_u_stablo(koren, -12);
    koren = dodaj_u_stablo(koren, -5);
    
    kriticni(koren);
    
    oslobodi(koren);
    
    return 0;
}