#include <iostream>

using namespace std;

struct Cvor {
    Cvor(int n):vrednost(n){};
    int vrednost;
    Cvor *levo = nullptr;
    Cvor *desno = nullptr;
};

/* ---- Pomocne funkcije ------- */

Cvor* dodaj_u_stablo(Cvor *koren, int n)
{
    if(koren == nullptr)
        return new Cvor(n);
    
    if(n <= koren->vrednost)
        koren->levo = dodaj_u_stablo(koren->levo, n);
    else
        koren->desno = dodaj_u_stablo(koren->desno, n);
    
    return koren;
}

void LKD(Cvor *koren)
{
    if(koren != nullptr)
    {
        LKD(koren->levo);
        cout << koren->vrednost << " ";
        LKD(koren->desno);
    }
}

void oslobodi(Cvor *koren)
{
    if(koren != nullptr)
    {
        oslobodi(koren->levo);
        oslobodi(koren->desno);
        delete koren;
    }
}

/*---------------------*/

Cvor *sledbenik(Cvor *koren, int broj)
{
    if(koren == nullptr)
        return nullptr;
    
    Cvor *skretanje_levo = nullptr;
    Cvor *tmp = koren;
    
    // Prolanazenje cvora u kome se nalazi zadati broj
    while(tmp != nullptr && tmp->vrednost != broj)
    {
        if(broj < tmp->vrednost)
        {
            skretanje_levo = tmp;
            tmp = tmp->levo;
        }
        else
            tmp = tmp->desno;
    }
    
    // Ako takav cvor ne postoji, ne postoji ni njegov sledbenik
    if(tmp == nullptr)
        return nullptr;
    
    // Ako pronadjeni cvor nema desnog sina, njegov sledbenik je cvor od koga je, 
    // tokom pronalazenja cvora, "skrenuto" levo
    if(tmp->desno == nullptr)
        return skretanje_levo;
    else // U suprotnom, sledbenik je najmanji u njegovom desnm podstablu
    {
        tmp = tmp->desno;
        while(tmp->levo != nullptr)
            tmp = tmp->levo;
        
        return tmp;
    }
}

int main()
{
    Cvor *koren = nullptr;
    
    koren = dodaj_u_stablo(koren, 8);
    koren = dodaj_u_stablo(koren, 5);
    koren = dodaj_u_stablo(koren, 11);
    koren = dodaj_u_stablo(koren, 2);
    koren = dodaj_u_stablo(koren, 7);
    koren = dodaj_u_stablo(koren, 10);
    koren = dodaj_u_stablo(koren, 12);
    koren = dodaj_u_stablo(koren, 1);
    koren = dodaj_u_stablo(koren, 3);
    koren = dodaj_u_stablo(koren, 6);
    koren = dodaj_u_stablo(koren, 9);

    Cvor *sledeci = sledbenik(koren, 7);
    
    if(sledeci == nullptr)
        cout << "Nema sledbenika" << endl;
    else
        cout << "Sledbenik je: " << sledeci->vrednost << endl;
    
    oslobodi(koren);
    
    return 0;
}