#include <iostream>

using namespace std;

struct Cvor {
    Cvor(int n):vrednost(n){};
    int vrednost;
    Cvor *levo = nullptr;
    Cvor *desno = nullptr;
};

/* ---- Pomocne funkcije ------- */

Cvor* dodaj_u_stablo(Cvor *koren, int n)
{
    if(koren == nullptr)
        return new Cvor(n);
    
    if(n <= koren->vrednost)
        koren->levo = dodaj_u_stablo(koren->levo, n);
    else
        koren->desno = dodaj_u_stablo(koren->desno, n);
    
    return koren;
}

void LKD(Cvor *koren)
{
    if(koren != nullptr)
    {
        LKD(koren->levo);
        cout << koren->vrednost << " ";
        LKD(koren->desno);
    }
}

void oslobodi(Cvor *koren)
{
    if(koren != nullptr)
    {
        oslobodi(koren->levo);
        oslobodi(koren->desno);
        delete koren;
    }
}


int najveci(Cvor *koren)
{
    if(koren == nullptr)
        return -1;
    
    if(koren->desno != nullptr)
        return najveci(koren->desno);
    else
        return koren->vrednost;
}

Cvor* brisanje(Cvor *koren, int broj)
{
    if(koren == nullptr)
        return koren;
    
    if(broj < koren->vrednost)
    {
        koren->levo = brisanje(koren->levo, broj);
        return koren;
    }
    else if (broj > koren->vrednost)
    {
        koren->desno = brisanje(koren->desno, broj);
        return koren;
    }
    
    // Cvor je list
    if(koren->levo == nullptr && koren->desno == nullptr)
    {
        delete koren;
        return nullptr;
    }
    
    // Cvor ima samo levog sina
    if(koren->desno == nullptr)
    {
        Cvor *tmp = koren->levo;
        delete koren;
        return tmp;
    }
    
    // Cvor ima samo desnog sina
    if(koren->levo == nullptr)
    {
        Cvor *tmp = koren->desno;
        delete koren;
        return tmp;
    }
    
    // Cvor ima oba sina
    int max = najveci(koren->levo);
    koren->vrednost = max;
    koren->levo = brisanje(koren->levo, max);
    return koren;
}

/*---------------------*/

Cvor *konkatenacija(Cvor *koren1, Cvor *koren2)
{
    if(koren1 == nullptr)
        return koren2;
    
    if(koren2 == nullptr)
        return koren1;
    
    Cvor *manje;
    Cvor *vece;
    
    // Nalazenje stabla sa manjim vrednostima
    if(koren1->vrednost < koren2->vrednost)
    {
        manje = koren1;
        vece = koren2;
    }   
    else
    {
        manje = koren2;
        vece = koren2;
    }
    
    Cvor *tmp = manje;
    
    int najveci_u_manjem;
    
    // Nalazenje cvora sa najvecom vrednoscu u stablu sa manjim vrednostima
    while(tmp->desno != nullptr)
        tmp = tmp->desno;    
    
    najveci_u_manjem = tmp->vrednost;
    
    manje = brisanje(manje, najveci_u_manjem);
    
    Cvor *novi_koren = new Cvor(najveci_u_manjem);
    
    novi_koren->levo = manje;
    novi_koren->desno = vece;
    
    return novi_koren;
}

int main()
{
    Cvor *koren1 = nullptr;
    Cvor *koren2 = nullptr;
    
    koren1 = dodaj_u_stablo(koren1, 4);
    koren1 = dodaj_u_stablo(koren1, 1);
    koren1 = dodaj_u_stablo(koren1, 3);
    koren1 = dodaj_u_stablo(koren1, 2);
 
    koren2 = dodaj_u_stablo(koren2, 8);
    koren2 = dodaj_u_stablo(koren2, 7);
    koren2 = dodaj_u_stablo(koren2, 6);
    koren2 = dodaj_u_stablo(koren2, 9);
    
    
    Cvor *novi_koren = konkatenacija(koren1, koren2);
    
    LKD(novi_koren);
    
    oslobodi(novi_koren);
    
    return 0;
}